aboutsummaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--elf/Makefile14
-rw-r--r--elf/ldconfig.c4
-rw-r--r--elf/readlib.c19
-rw-r--r--elf/tst-ldconfig-soname-lib-with-soname.c1
-rw-r--r--elf/tst-ldconfig-soname-lib-without-soname.c1
-rw-r--r--elf/tst-ldconfig-soname.sh49
-rw-r--r--sysdeps/generic/ldconfig.h2
7 files changed, 67 insertions, 23 deletions
diff --git a/elf/Makefile b/elf/Makefile
index 2fc6391..0d19964 100644
--- a/elf/Makefile
+++ b/elf/Makefile
@@ -627,6 +627,7 @@ tests-special += \
$(objpfx)noload-mem.out \
$(objpfx)tst-ldconfig-X.out \
$(objpfx)tst-ldconfig-p.out \
+ $(objpfx)tst-ldconfig-soname.out \
$(objpfx)tst-leaks1-mem.out \
$(objpfx)tst-rtld-help.out \
# tests-special
@@ -859,6 +860,8 @@ modules-names += \
tst-initorderb2 \
tst-latepthreadmod \
tst-ldconfig-ld-mod \
+ tst-ldconfig-soname-lib-with-soname \
+ tst-ldconfig-soname-lib-without-soname \
tst-main1mod \
tst-nodelete2mod \
tst-nodelete-dlclose-dso \
@@ -2402,6 +2405,17 @@ $(objpfx)tst-ldconfig-p.out : tst-ldconfig-p.sh $(objpfx)ldconfig
'$(run-program-env)' > $@; \
$(evaluate-test)
+LDFLAGS-tst-ldconfig-soname-lib-with-soname.so = \
+ -Wl,-soname,libtst-ldconfig-soname-lib-with-soname.so.1
+
+$(objpfx)tst-ldconfig-soname.out : tst-ldconfig-soname.sh \
+ $(objpfx)ldconfig \
+ $(objpfx)tst-ldconfig-soname-lib-with-soname.so \
+ $(objpfx)tst-ldconfig-soname-lib-without-soname.so
+ $(SHELL) $< '$(common-objpfx)' '$(test-wrapper-env)' \
+ '$(run-program-env)' > $@; \
+ $(evaluate-test)
+
# Test static linking of all the libraries we can possibly link
# together. Note that in some configurations this may be less than the
# complete list of libraries we build but we try to maxmimize this list.
diff --git a/elf/ldconfig.c b/elf/ldconfig.c
index 3f1b30c..2fc45ad 100644
--- a/elf/ldconfig.c
+++ b/elf/ldconfig.c
@@ -616,7 +616,7 @@ manual_link (char *library)
goto out;
}
if (soname == NULL)
- soname = implicit_soname (libname, flag);
+ soname = xstrdup (libname);
create_links (real_path, path, libname, soname);
free (soname);
out:
@@ -849,7 +849,7 @@ search_dir (const struct dir_entry *entry)
}
if (soname == NULL)
- soname = implicit_soname (direntry->d_name, flag);
+ soname = xstrdup (direntry->d_name);
/* A link may just point to itself. */
if (is_link)
diff --git a/elf/readlib.c b/elf/readlib.c
index c5c3591..bc13d9a 100644
--- a/elf/readlib.c
+++ b/elf/readlib.c
@@ -166,24 +166,5 @@ process_file (const char *real_file_name, const char *file_name,
return ret;
}
-/* Returns made up soname if lib doesn't have explicit DT_SONAME. */
-
-char *
-implicit_soname (const char *lib, int flag)
-{
- char *soname = xstrdup (lib);
-
- /* Aout files don't have a soname, just return the name
- including the major number. */
- char *major = strstr (soname, ".so.");
- if (major)
- {
- char *dot = strstr (major + 4, ".");
- if (dot)
- *dot = '\0';
- }
- return soname;
-}
-
/* Get architecture specific version of process_elf_file. */
#include <readelflib.c>
diff --git a/elf/tst-ldconfig-soname-lib-with-soname.c b/elf/tst-ldconfig-soname-lib-with-soname.c
new file mode 100644
index 0000000..d1ab56a
--- /dev/null
+++ b/elf/tst-ldconfig-soname-lib-with-soname.c
@@ -0,0 +1 @@
+/* This file intentionally left blank */
diff --git a/elf/tst-ldconfig-soname-lib-without-soname.c b/elf/tst-ldconfig-soname-lib-without-soname.c
new file mode 100644
index 0000000..d1ab56a
--- /dev/null
+++ b/elf/tst-ldconfig-soname-lib-without-soname.c
@@ -0,0 +1 @@
+/* This file intentionally left blank */
diff --git a/elf/tst-ldconfig-soname.sh b/elf/tst-ldconfig-soname.sh
new file mode 100644
index 0000000..406f526
--- /dev/null
+++ b/elf/tst-ldconfig-soname.sh
@@ -0,0 +1,49 @@
+#!/bin/sh
+# Test that ldconfig creates symlinks according to the library's soname
+# (and in particular, does not create symlinks for libraries without a soname)
+# Copyright (C) 2000-2023 Free Software Foundation, Inc.
+# Copyright The GNU Toolchain Authors.
+# This file is part of the GNU C Library.
+
+# The GNU C Library is free software; you can redistribute it and/or
+# modify it under the terms of the GNU Lesser General Public
+# License as published by the Free Software Foundation; either
+# version 2.1 of the License, or (at your option) any later version.
+
+# The GNU C Library is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# Lesser General Public License for more details.
+
+# You should have received a copy of the GNU Lesser General Public
+# License along with the GNU C Library; if not, see
+# <https://www.gnu.org/licenses/>.
+
+set -ex
+
+common_objpfx=$1
+test_wrapper_env=$2
+run_program_env=$3
+
+testroot="${common_objpfx}elf/bug30125-test-directory"
+cleanup () {
+ rm -rf "$testroot"
+}
+trap cleanup 0
+
+rm -rf "$testroot"
+mkdir -p $testroot/lib
+cp "${common_objpfx}elf/tst-ldconfig-soname-lib-with-soname.so" \
+ $testroot/lib/libtst-ldconfig-soname-lib-with-soname.so.1.2.3
+cp "${common_objpfx}elf/tst-ldconfig-soname-lib-without-soname.so" \
+ $testroot/lib/libtst-ldconfig-soname-lib-without-soname.so.1.2.3
+
+${test_wrapper_env} \
+${run_program_env} \
+${common_objpfx}elf/ldconfig -vn $testroot/lib
+
+LINKS=$(cd $testroot/lib && find . -type l)
+if [ "$LINKS" != "./libtst-ldconfig-soname-lib-with-soname.so.1" ]; then
+ echo "error: $0 - extra symlinks found"
+ exit 1
+fi
diff --git a/sysdeps/generic/ldconfig.h b/sysdeps/generic/ldconfig.h
index 0e1a9a9..e9e9e19 100644
--- a/sysdeps/generic/ldconfig.h
+++ b/sysdeps/generic/ldconfig.h
@@ -90,8 +90,6 @@ extern int process_file (const char *real_file_name, const char *file_name,
const char *lib, int *flag, unsigned int *isa_level,
char **soname, int is_link, struct stat *stat_buf);
-extern char *implicit_soname (const char *lib, int flag);
-
/* Declared in readelflib.c. */
extern int process_elf_file (const char *file_name, const char *lib,
int *flag, unsigned int *isa_level, char **soname,